## com.fasterxml.jackson.databind
Class JsonDeserializer<T>

    java.lang.Object
      com.fasterxml.jackson.databind.JsonDeserializer<T>

Direct Known Subclasses:
  AbstractDeserializer, JsonDeserializer.None, StdDeserializer, TypeWrappedDeserializer

    public abstract class JsonDeserializer<T>

extends Object

Abstract class that defines API used by `ObjectMapper` (and other chained `JsonDeserializer`s too) to deserialize Objects of arbitrary types from JSON, using provided `JsonParser`.

Custom deserializers should usually not directly extend this class, but instead extend `StdDeserializer` (or its subtypes like `StdScalarDeserializer`).

If deserializer is an aggregate one -- meaning it delegates handling of some of its contents by using other deserializer(s) -- it typically also needs to implement `ResolvableDeserializer`, which can locate dependant deserializers. This is important to allow dynamic overrides of deserializers; separate call interface is needed to separate resolution of dependant deserializers (which may have cyclic link back to deserializer itself, directly or indirectly).

In addition, to support per-property annotations (to configure aspects of deserialization on per-property basis), deserializers may want to implement `ContextualDeserializer`, which allows specialization of deserializers: call to `ContextualDeserializer.createContextual(com.fasterxml.jackson.databind.DeserializationContext, com.fasterxml.jackson.databind.BeanProperty)` is passed information on property, and can create a newly configured deserializer for handling that particular property.

If both `ResolvableDeserializer` and `ContextualDeserializer` are implemented, resolution of deserializers occurs before contextualization.

Nested Class Summary
`static class` `JsonDeserializer.None` This marker class is only to be used with annotations, to indicate that no deserializer is configured.

Constructor Summary
`JsonDeserializer()`

Method Summary
`abstract T` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`T` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, T intoValue)` Alternate deserialization method (compared to the most commonly used, `deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` `deserializeWithType(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
`T` `getEmptyValue()` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`Collection<Object>` `getKnownPropertyNames()` Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name.
`T` `getNullValue()` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`ObjectIdReader` `getObjectIdReader()` Accessor that can be used to check whether this deserializer is expecting to possibly get an Object Identifier value instead of full value serialization, and if so, should be able to resolve it to actual Object instance to return as deserialized value.
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`JsonDeserializer<T>` `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JsonDeserializer

    public JsonDeserializer()

Method Detail

### deserialize

    public abstract T deserialize(com.fasterxml.jackson.core.JsonParser jp,
                                  DeserializationContext ctxt)
                           throws IOException,
                                  com.fasterxml.jackson.core.JsonProcessingException

  Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

  Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

  Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

  Parameters:
    `jp` - Parsed used for reading JSON content
    `ctxt` - Context that can be used to access information about this deserialization activity.
  Returns:
    Deserializer value
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserialize

    public T deserialize(com.fasterxml.jackson.core.JsonParser jp,
                         DeserializationContext ctxt,
                         T intoValue)
                  throws IOException,
                         com.fasterxml.jackson.core.JsonProcessingException

  Alternate deserialization method (compared to the most commonly used, `deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used for all supported types; most commonly it is used for Collections and Maps.

  Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithType

    public Object deserializeWithType(com.fasterxml.jackson.core.JsonParser jp,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException,
                                      com.fasterxml.jackson.core.JsonProcessingException

  Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

  Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

  Parameters:
    `typeDeserializer` - Deserializer to use for handling type information
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### unwrappingDeserializer

    public JsonDeserializer<T> unwrappingDeserializer(NameTransformer unwrapper)

  Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

  Default implementation just returns 'this' indicating that no unwrapped variant exists

### getNullValue

    public T getNullValue()

  Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

  Note that deserializers are allowed to call this just once and then reuse returned value; that is, method is not guaranteed to be called once for each conversion.

  Default implementation simply returns null.

### getEmptyValue

    public T getEmptyValue()

  Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `getNullValue()` (which in turn is usually simply Java null), but it can be overridden for types. Or, if type should never be converted from empty String, method can also throw an exception.

  Default implementation simple calls `getNullValue()` and returns value.

### getKnownPropertyNames

    public Collection<Object> getKnownPropertyNames()

  Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name. This is only to be used for error reporting and diagnostics purposes (most commonly, to accompany "unknown property" exception).

  Since:
    2.0

### isCachable

    public boolean isCachable()

  Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

  Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

  Default implementation returns false, to indicate that no caching is done.

### getObjectIdReader

    public ObjectIdReader getObjectIdReader()

  Accessor that can be used to check whether this deserializer is expecting to possibly get an Object Identifier value instead of full value serialization, and if so, should be able to resolve it to actual Object instance to return as deserialized value.

  Default implementation returns null, as support can not be implemented generically. Some standard deserializers (most notably `BeanDeserializer`) do implement this feature, and may return reader instance, depending on exact configuration of instance (which is based on type, and referring property).

  Returns:
    ObjectIdReader used for resolving possible Object Identifier value, instead of full value serialization, if deserializer can do that; null if no Object Id is expected.
  Since:
    2.0

Copyright © 2012 fasterxml.com. All Rights Reserved.